<script lang="ts">
import Vue from 'vue';
import { getClient } from '../../plugins/contentful';
import { CONTENT_TYPES } from '../../common/content-types';
import {
  convertToCaseSensitiveLocale,
  getUrlFromContentfulImage,
} from '../../common/util';
import { editQueryParams } from '~/mixins/index';

import {
  CtfAsset,
  CtfButton,
  CtfEntry,
  CtfNextStep,
} from '~/models/content-types.dto';

export default Vue.extend({
  name: 'NextStep',
  mixins: [editQueryParams],
  props: {
    entryId: {
      type: String,
      required: false,
      default: '4JnS6yheQLYyaDzNGv5IIi',
    },
    disableAnimations: {
      type: Boolean,
      required: false,
    },
    isSingleColumn: {
      type: Boolean,
      required: false,
      default: false,
    },
    hasVerticalLine: {
      type: Boolean,
      required: false,
      default: true,
    },
    contentData: {
      // if you want to use $content and not contentful for the data here
      // If you choose to use this component, you should pass the correct localized content from the page
      type: Object as () => CtfEntry<CtfNextStep> | null,
      required: false,
      default: null,
    },
    enableButtonIcons: {
      type: Boolean,
      required: false,
    },
  },
  data(): { data: CtfEntry<CtfNextStep> | null } {
    return {
      data: null,
    };
  },
  async fetch() {
    if (this.contentData) {
      this.data = this.contentData;
      return;
    }

    const [nextStepEntry]: CtfEntry<CtfNextStep> = (
      await getClient().getEntries({
        content_type: CONTENT_TYPES.NEXT_STEPS,
        locale: convertToCaseSensitiveLocale(this.$i18n.locale),
        'sys.id': this.entryId,
      })
    ).items;

    this.data = nextStepEntry;
  },
  computed: {
    isLikeAltLayout() {
      return this.data.fields.calculatorData;
    },
    primaryButton(): CtfButton {
      return this.data.fields.primaryButton?.fields;
    },
    secondaryButton(): CtfButton {
      return this.data.fields.secondaryButton?.fields;
    },
    tertiaryButton(): CtfButton {
      return this.data.fields.tertiaryButton?.fields;
    },
    image(): CtfAsset {
      return {
        ...this.data.fields.image?.fields,
        image: {
          fields: {
            file: {
              url: getUrlFromContentfulImage(
                this.data.fields.image?.fields.image,
              ),
            },
          },
        },
      };
    },
    additionalButton(): CtfButton {
      return this.data.fields.additionalButton?.fields;
    },
  },
});
</script>

<template>
  <SlpContainer>
    <SlpContainer class="slp-my-96">
      <SlpRow class="w-100 prevent-overflow">
        <!-- LEFT COLUMN-->
        <SlpColumn
          :cols="isSingleColumn ? 12 : 6"
          size="lg"
          :data-aos="!disableAnimations && 'fade-right'"
          data-aos-duration="800"
        >
          <!-- HEADING -->
          <SlpTypography
            v-if="data.fields.heading"
            class="slp-mb-16 slp-pr-72"
            variant="heading2-bold"
            tag="h2"
          >
            <slot name="ft-text">{{ data.fields.heading }}</slot>
          </SlpTypography>
          <!-- TAGLINE-->
          <SlpTypography
            v-if="data.fields.tagline"
            class="slp-mb-24"
            variant="heading4"
            tag="p"
          >
            {{ data.fields.tagline }}
          </SlpTypography>
          <!-- PRIMARY BUTTON -->
          <SlpButton
            v-if="primaryButton"
            :variant="primaryButton.variation"
            :href="updateFreeTrialGlmContent(primaryButton.externalUrl)"
            :data-ga-name="primaryButton.dataGaName"
            :data-ga-location="primaryButton.dataGaLocation"
            :aria-label="`${primaryButton.dataGaLocation} ${primaryButton.dataGaName}`"
          >
            {{ primaryButton.text }}
            <SlpIcon
              v-if="primaryButton.variation === 'tertiary'"
              icon="gl-chevron-lg-right"
              alt="Chevron Right Icon"
            />
            <SlpIcon
              v-else-if="enableButtonIcons && primaryButton.iconName"
              class="slp-ml-8"
              :icon="primaryButton.iconName"
              :alt="primaryButton.iconName"
              :variant="primaryButton.iconVariant"
              :name="primaryButton.iconName"
            />
          </SlpButton>
          <!-- SECONDARY BUTTON -->
          <SlpButton
            v-if="secondaryButton"
            :variant="secondaryButton.variation"
            :href="secondaryButton.externalUrl"
            :data-ga-name="secondaryButton.dataGaName"
            :data-ga-location="secondaryButton.dataGaLocation"
            :aria-label="`${secondaryButton.dataGaLocation} ${secondaryButton.dataGaName}`"
            class="slp-ml-lg-24 secondary-button"
          >
            {{ secondaryButton.text }}
            <SlpIcon
              v-if="secondaryButton.variation === 'tertiary'"
              icon="gl-chevron-lg-right"
              alt="Chevron Right Icon"
            />
            <SlpIcon
              v-else-if="enableButtonIcons && secondaryButton.iconName"
              class="slp-ml-8"
              :icon="secondaryButton.iconName"
              :alt="secondaryButton.iconName"
              :variant="secondaryButton.iconVariant"
              :name="secondaryButton.iconName"
            />
          </SlpButton>
          <!-- ADDITIONAL BUTTON -->
          <SlpButton
            v-if="additionalButton"
            :variant="additionalButton.variation"
            :href="additionalButton.externalUrl"
            :data-ga-name="additionalButton.dataGaName"
            :data-ga-location="additionalButton.dataGaLocation"
            :aria-label="`${additionalButton.dataGaLocation} ${additionalButton.dataGaName}`"
            class="slp-ml-lg-24 secondary-button"
          >
            {{ additionalButton.text }}
            <SlpIcon
              v-if="additionalButton.variation === 'tertiary'"
              icon="gl-chevron-lg-right"
              alt="Chevron Right Icon"
            />
            <SlpIcon
              v-else-if="enableButtonIcons && additionalButton.iconName"
              class="slp-ml-8"
              :icon="additionalButton.iconName"
              :alt="additionalButton.iconName"
              :variant="additionalButton.iconVariant"
              :name="additionalButton.iconName"
            />
          </SlpButton>
        </SlpColumn>
        <!-- RIGHT COLUMN-->
        <SlpColumn
          v-if="!isLikeAltLayout"
          class="slp-mt-64-sm"
          :class="{
            'slp-mt-0 slp-flex slp-align-items-center': !hasVerticalLine,
          }"
          :cols="6"
          size="lg"
          :data-aos="!disableAnimations && 'fade-left'"
          data-aos-duration="800"
        >
          <div class="slp-flex w-100">
            <div v-if="hasVerticalLine" class="vertical-line" />
            <div
              class="slp-flex w-100 right-column"
              :class="{ 'slp-align-items-center': !hasVerticalLine }"
            >
              <img
                class="slp-mb-16 right-column_image"
                :src="image.image.fields.file.url"
                :alt="image.altText"
              />
              <SlpTypography
                v-if="data.fields.secondaryTagline"
                class="slp-mb-24"
                :class="{ 'slp-ml-lg-32': isSingleColumn }"
                variant="heading4"
                tag="p"
              >
                {{ data.fields.secondaryTagline }}
              </SlpTypography>
              <SlpButton
                v-if="tertiaryButton"
                :variant="tertiaryButton.variation"
                :href="tertiaryButton.externalUrl"
                :data-ga-name="tertiaryButton.dataGaName"
                :data-ga-location="tertiaryButton.dataGaLocation"
                :aria-label="`${tertiaryButton.dataGaLocation} ${tertiaryButton.dataGaName}`"
              >
                {{ tertiaryButton.text }}
                <SlpIcon
                  v-if="tertiaryButton.variation === 'tertiary'"
                  icon="gl-chevron-lg-right"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </div>
          </div>
        </SlpColumn>
        <!-- RIGHT COLUMNS FOR CALCULATOR VARIANT-->
        <SlpColumn
          v-else
          class="slp-mt-64-sm"
          :cols="6"
          size="lg"
          :data-aos="!disableAnimations && 'fade-left'"
          data-aos-duration="800"
        >
          <SlpRow>
            <SlpColumn
              class="nxt-stp-card"
              :cols="6"
              size="lg"
              data-aos-duration="800"
            >
              <SlpIcon size="md" :icon="data.fields.calculatorData.col1.icon" />
              <SlpTypography variant="heading5" tag="p">
                {{ data.fields.calculatorData.col1.text }}
              </SlpTypography>
              <SlpButton
                :href="data.fields.calculatorData.col1.button?.href"
                :data-ga-name="data.fields.calculatorData.col1.button?.gaName"
                :data-ga-location="
                  data.fields.calculatorData.col1.button?.gaLocation
                "
                :variant="data.fields.calculatorData.col1.button?.variant"
              >
                {{ data.fields.calculatorData.col1.button?.text }}
                <SlpIcon
                  v-if="
                    data.fields.calculatorData.col1.button?.variant ===
                    'tertiary'
                  "
                  icon="gl-chevron-lg-right"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </SlpColumn>
            <SlpColumn
              class="nxt-stp-card"
              :cols="6"
              size="lg"
              data-aos-duration="800"
            >
              <SlpIcon size="md" :icon="data.fields.calculatorData.col2.icon" />
              <SlpTypography variant="heading5" tag="p">
                {{ data.fields.calculatorData.col2.text }}
              </SlpTypography>
              <SlpButton
                :href="data.fields.calculatorData.col2.button?.href"
                :data-ga-name="data.fields.calculatorData.col2.button?.gaName"
                :data-ga-location="
                  data.fields.calculatorData.col2.button?.gaLocation
                "
                :variant="data.fields.calculatorData.col2.button?.variant"
              >
                {{ data.fields.calculatorData.col2.button?.text }}
                <SlpIcon
                  v-if="
                    data.fields.calculatorData.col2.button?.variant ===
                    'tertiary'
                  "
                  icon="gl-chevron-lg-right"
                  alt="Chevron Right Icon"
                />
              </SlpButton>
            </SlpColumn>
          </SlpRow>
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </SlpContainer>
</template>

<style lang="scss" scoped>
.w-100 {
  width: 100%;
  overflow-x: hidden;
}

.slp-btn {
  &.slp-btn-tertiary {
    padding-left: 0;
  }

  @media (max-width: $breakpoint-lg) {
    width: 100%;
    justify-content: center;
    &.slp-btn-tertiary {
      width: 100%;
      justify-content: flex-start;

      &.force-center {
        @media (max-width: $breakpoint-lg) {
          justify-content: center;
        }
      }
    }
  }
}

.slp-mt-64-sm {
  @media (max-width: $breakpoint-lg) {
    margin-top: $spacing-64;
  }
}

.vertical-line {
  display: none;
  @media (min-width: $breakpoint-lg) {
    display: block;
    border-left: 2px solid $color-surface-500;
    margin-right: 96px;
    margin-left: 96px;
  }
}

.right-column {
  display: flex;
  flex-direction: column;

  &_image {
    max-width: 210px;

    @media (max-width: $breakpoint-lg) {
      align-self: center;
    }
  }

  .slp-btn {
    @media (min-width: $breakpoint-lg) {
      width: fit-content;
    }
  }
}

.secondary-button {
  @media (max-width: $breakpoint-lg) {
    margin-top: px;
  }
}

.nxt-stp-card {
  margin-bottom: $spacing-32;

  & > *,
  .slp-btn-tertiary {
    margin-bottom: $spacing-24;
    padding: 0 2rem 0 0;
    @media (min-width: $breakpoint-lg) {
      padding: 0 1rem;
    }
  }
}
</style>
